#CONTROLCODES 1
#SYMFILE "@:SLOTS.SYM"
## Set up my Pseudo Constants.
## Mostly named variables for various
## System Memory Pointers
   GOSUB SETREGVARS

## This will be changed to select LOADED from DEVICE
   DEVICE = 8

## Check for all Necessary File assets
## This routine WILL NOT RETURN unless all
## assets are found.
   GOSUB CHECK.FOR.NECESSARY.FILE.ASSETS

## Loads the code for the alternate
## Control-C/BRK handler
   PRINT "{CR}"
   PRINT "{WHT}INSTALLING CTRL/C HANDLER{YEL}."
   RESTORE STOPHANDLER:GOSUB POKEMLROUTINE

## Call the just Poked Code to disable CTRL/C/BRK
SYS $0620

## Functions to convert a BYTE to signed
## And and Unsigned Word to Signed
  DEF FN SIGNED.BYTE(N) = N+256*(N>127)
  DEF FN SW(W)=W + 65536 * (W > 32767)

## Set ROM Bank for Peeks to 0
## and retrieve the current ROM Version
## This program requires r47 for LoadBMX
## To work properly.  Disallows PRERELEASE r47
## because the required feature was a late addition to
## r47
  OB = PEEK(1):BANK PEEK(0),0
  PRERELEASE.ROM = 0
  ROM.VERSION=FN SIGNED.BYTE(PEEK($FF80))
  IF ROM.VERSION < 0 THEN PRERELEASE.ROM = -1
  GOOD.ROM = (ROM.VERSION < -47) OR (ROM.VERSION >= 47)
  IF NOT GOOD.ROM THEN PRINT "{WHT}ROM VERSION {RED}";ROM.VERSION;"{WHT} NOT SUPPORTED. PLEASE UPGRADE.{CR}{CR}":END
  IF ROM.VERSION < -47 OR ROM.VERSION >= 47 THEN DRAWIMAGE.IS.BANKAWARE = -1
  ROM.VERSION = ABS(ROM.VERSION)
BANK PEEK(0), OB

## Zero the Palette to prevent visible
## Screen Flicker during SCREEN mode change
  GOSUB PAL2BLACK

## Clear the Screen
  COLOR 1,0:CLS
## Set 320x240 Graphiics Mode
  SCREEN $80
## Set ISO character mode instead of PETSCII
  PRINT "{ISO ON}";

## Clear the Graphics Screen.  Set the GRAPH.BANK
## Variable used by LOADBMX
  RECT 0,0,XLIMIT,YLIMIT, 0
  GRAPH.BANK=2

## Load the Splash Image and then put
## The Skip Intro Message on Top of it.
  F$="SPLASH.BMX":GOSUB LOADBMX2
  CHAR 116,206,5,CHR$(6)+"ESC -"
  CHAR 147,206,1,"Skip Intro"

## Flush the Keyboard Buffer
  FOR Z=0 TO -1 STEP 0:GET X$:Z=(X$=""):NEXT

## Intro Audio takes a couple seconds to load
## Show wait Message and load it
  LOCATE 2,2:COLOR 1,0:PRINT "LOADING INTRO AUDIO{LIGHT GREEN}...";
  BLOAD "INTRO.AUD",DEVICE,GRAPH.BANK,$A000

## Load is Done, So clear the wait Message
  COLOR 1,0:LOCATE 2,2:PRINT RPT$(32,30);

## If USER has pressed the ESC Key skip the
## Rest of the Intro
  GET X$:IF X$="{ESC}" THEN RESTART.SLOTS

## Play the Intro Audio just loaded.
  AUDIOBANK=2
  V.RATE=25
  AUD.LOOPS = 111
  GOSUB PLAY.AUDIO2

## After the Audio is done playing Then Load the rest of the Animation
  LOCATE 2,2:COLOR 1,0:PRINT "LOADING ANIMATION PALETTE{LIGHT GREEN}...";
  GOSUB LOAD.THE.ANIMATION.PALETTE
 CLS

## GOTO HERE TO RESTART THE GAME
RESTART.SLOTS:
  DEF FN SIGNED.BYTE(N) = N+256*(N>127)
  OB = PEEK(1):BANK PEEK(0),0
  PRERELEASE.ROM = 0
  ROM.VERSION=FN SIGNED.BYTE(PEEK($FF80))
  IF ROM.VERSION < 0 THEN PRERELEASE.ROM = -1
  GOOD.ROM = (ROM.VERSION < -47) OR (ROM.VERSION >= 47)
  IF NOT GOOD.ROM THEN PRINT "{WHT}ROM VERSION {RED}";ROM.VERSION;"{WHT} NOT SUPPORTED. PLEASE UPGRADE.{CR}{CR}":END
  IF ROM.VERSION < -48 OR ROM.VERSION >= 48 THEN RELEASE.ROM = -1
  ROM.VERSION = ABS(ROM.VERSION)
  BANK PEEK(0),OB

## UNREM TO TEST ALTERNATE DRAWING CODE
## OR JUST RUN ON EARLIER EMULATOR VERSION
## ROM.VERSION = 47


LOCATE 2,2:COLOR 1,0:PRINT "LOADING ASSETS{LIGHT GREEN}...";
NUMCOINS = 10
DIM BIT.MASK(8)
DIM SPR.X(NUMCOINS)
DIM SPR.Y(NUMCOINS)
DIM SPR.Y.VALS%(87,NUMCOINS)
DIM SPR.YINC(NUMCOINS)
DIM SPR.DONE(NUMCOINS)
DIM PAL.PTRLO(5)

## INITIALIZE THE COIN SPRITES.
## And the Y Increments for the "Coin Rain"
 FOR I = 1 TO NUMCOINS
   SPR.Y.VALS%(0, I) = (0-(INT(RND(.)*20)))-32
   SPR.YINC(I)=INT(RND(.)*7)+3
 NEXT

## AND INITIALIZE THE LOOK UP TABLE FOR THE Y "Raining"
## Coordinates (avoids math in the "Rain Coins" Animation)

  ## DEBUG CODE
  ## GOSUB SHOWTEXT
  ## LOCATE 1,1
  ## PRINT "Initializing Coin Rain"

CoinLoopStop = 0
FOR YVals = 2 TO 87
   FOR SI = 1 TO NUMCOINS
    DONE.INCREMENT = (SPR.Y.VALS%(YVals-1,SI)>= 240)
    IF DONE.INCREMENT THEN SPR.Y.VALS%(YVals,SI) = SPR.Y.VALS%(YVals-1,SI):GOTO SKIP.COIN.INC
    SPR.Y.VALS%(YVals,SI) = SPR.Y.VALS%(YVals-1,SI)+SPR.YINC(SI)
    IF YVals>CoinLoopStop THEN CoinLoopStop = YVals
   SKIP.COIN.INC:
   NEXT
NEXT YVals

  ## DEBUG CODE
  ## CLS
  ## PRINT
  ## PRINT "DONE WITH RAIN":SLEEP 60

## READ IN THE BITMASKS FOR THE BIGWORD ROUTINE
 RESTORE BITMAPS
   FOR I=1 TO 8:READ BIT.MASK(I):NEXT

## Initialize the FM Chip
 FMINIT
## And set channel default Volumes
FOR I = 0 TO 7:FMVOL I, 55:NEXT

## General Purpose FN definitions.
## CONVERT TO SIGNED RANGE
  DEF FN SW(W)=W + 65536 * (W > 32767)
## CONVERT TO UNSIGNED RANGE
  DEF FN UW(W)=W-65536*(W<0)

## Get Lo Byte of Word Value for pointers
  DEF FN Lo.Byte(X)=(FN SW(X)) AND $FF
## Get Hi Byte of Word Value for pointers
  DEF FN Hi.Byte(X)=INT(FN UW(X)/256)

## Round function
  DEF FN ROUND(X) = INT(X+.5)

## Just some Psuedo Constants for the Slot Machine "Math"
DIM FRUIT.COLORS%(17)
DIM FRUIT.COLORS$(17)
DIM COLOR.NAME$(15)
     RED = 2:FRUIT.COLORS$(2)="{RED}":COLOR.NAME$(2)="Red"
  YELLOW = 7:FRUIT.COLORS$(7)="{YEL}":COLOR.NAME$(7)="Yellow"
   GREEN = 5:FRUIT.COLORS$(5)="{LIGHT GREEN}":COLOR.NAME$(5)="Green"
   FRUIT.COLORS$(8)="{ORG}":COLOR.NAME$(8) = "Orange"
  PURPLE = 4:FRUIT.COLORS$(4)="{PUR}":COLOR.NAME$(4) = "Purple"
    GOLD = 9:FRUIT.COLORS$(9)="{BROWN}":COLOR.NAME$(9) = "Gold"

    BLUE = 6:FRUIT.COLORS$(6)="{BLU}"
    GRAY = 12:FRUIT.COLORS$(12)="{GREY 3}"

    APPLE =  1:FRUIT.COLORS%(1) = RED
   BANANA =  2:FRUIT.COLORS%(2) = YELLOW
    LEMON =  3:FRUIT.COLORS%(3) = YELLOW
    MELON =  4:FRUIT.COLORS%(4) = GREEN
   ORANGE =  5:FRUIT.COLORS%(5) = 8
     PLUM =  6:FRUIT.COLORS%(6) = PURPLE
   GRAPES =  7:FRUIT.COLORS%(7) = PURPLE
    HEART =  8:FRUIT.COLORS%(8) = RED
  CHERRYS =  9:FRUIT.COLORS%(9) = RED
     BELL = 10:FRUIT.COLORS%(10) = GOLD
HORSESHOE = 11:FRUIT.COLORS%(11) = GOLD
 SHAMROCK = 12:FRUIT.COLORS%(12) = GREEN
     COIN = 13:FRUIT.COLORS%(13) = GOLD
      BAR = 14:FRUIT.COLORS%(14) = GOLD
    SEVEN = 15:FRUIT.COLORS%(15) = RED
  DIAMOND = 16:FRUIT.COLORS%(16) = BLUE
COMMANDER = 17:FRUIT.COLORS%(17) = GRAY

## Preformatted string for "non-printable" up down arrow chars.
 ARROWS$ = CHR$($80)+CHR$($18)+CHR$($80)+CHR$($19)

## Load the drawing array for TEXTBOX
GOSUB LoadDCharsCP437
## Setup Important "Psuedo Constants"
GOSUB SETREGVARS

## Make the Text Layer visible.
GOSUB SHOWTEXT
DIM SLOT.STOP(4,2)
DIM SLOT.FRM(4)
DIM FRAME.ADDR(17,3)

## Load all the Assets
GOSUB LOADFRAMES

## Set up the Frames for the "Spinning X16"
DIM SPINFRAMES(16,2)
RESTORE FRAMEDATA
FOR SPR.FRAMES = 1 TO 16
    READ S.INDX:S.INDX = S.INDX-1
    SPINFRAMES(SPR.FRAMES,1) = SPINSPRITE + S.INDX
    READ SPINFRAMES(SPR.FRAMES,2)
NEXT
CURFRAME = 1
LASTSPRITE = 16



## If this isn't a RESTART then do the fancy
## Clear screen for the Intro bitmap.
IF NOT RESTART.TRUE AND X$<>"{ESC}" THEN GOSUB ALTLINEWIPE

## Hide the layers
  GOSUB HIDEALL
## and Zero the Palette
  GOSUB PAL2BLACK
## So there is no Visible Flicker when changing modes.
  SCREEN $80
## HIDE THE GRAPHICS LAYER AGAIN (SCREEN REENABLED IT)
  GOSUB HIDEGRAPHICS

## Now restore the Default Palette
 GOSUB SET.DEFAULT.PALETTE
## Set Color 9 to Gold Instead of Brown
 GOSUB SetBrownToGold
## Turn on the Spinning X16 sprite
 SPRITE SPINSPRITE, 3
## Set Color indexs 251 to 255 black
## (Used for BLINKENLIGHTS)
 GOSUB LAST5.PALBLACK
PRINT "{ISO ON}"
BVLOAD "SLOTS.FONT",DEVICE,1,$F000
CLS:RECT 0,0,319,239,0
IF ROM.VERSION >= 48 THEN SKIP.DrawMsg
   GOSUB SHOWTEXT
   COLOR 15,0:CLS:LOCATE 2,1
   PRINT " Drawing {WHT}Blinking{GREY 1} Lights"
   PRINT
   RV$=STR$(ROM.VERSION)
   RV$=RIGHT$(RV$,LEN(RV$)-1)
   PRINT " System {WHT}ROM {LIGHT GREEN}r{WHT}";RV$;"{GREY 1} Detected."
   PRINT
   PRINT "Alt Drawing Code takes a little Longer."
   PRINT "{GREY 1}Upgrade to {LIGHT GREEN}r{WHT}48{GREY 1} for faster code."

   VPOKE 1, $FBF6,$22
   VPOKE 1, $FBF7,$02
   VPOKE 1, $FBF8,$33
   VPOKE 1, $FBF9,$03
   VPOKE 1, $FBFA,$44
   VPOKE 1, $FBFB,$04
   VPOKE 1, $FBFC,$55
   VPOKE 1, $FBFD,$05


SKIP.DrawMsg:
   GOSUB BLINKENLIGHTS
   IF ROM.VERSION < 48 THEN GOSUB LAST5.PALBLACK:GOSUB HIDEGRAPHICS
   CLS
   GOSUB FRAMESLOTS


  X = RND(-TI)

## Set the initial position for all the "Slot Reels"
  FOR I=1 TO 3
    SLOT.FRM(I) = 1
  NEXT

## YM-2151 "Drum" Patchs that have a "ringing" sound
  BELL(1) = 53
  BELL(2) = 33
  BELL(3) = 51
  BELL(4) = 59

  MY.POT = 100000
  MY.BET = 25
  GOSUB SHOW.THE.POT
  GOSUB SHOW.THE.BET
  GOSUB SETBLITWIDTH
## UNHIDE THE LAYERS
  GOSUB SHOWALL
  Y1 = 40
  FRM = INT(RND(.)*4)+BAR
  FMVOL 7,59

  BLITWIDTH=64
  BLITLINES=64
  GOSUB SETBLITWIDTH
  Y1=40

FOR I = 1 TO 3
    X1=SLOT.X(I)
    GOSUB SETBLITXY
    GOSUB SLOW.BLITTER
## CLICK SOUND
    FMDRUM 7,82
NEXT


GOTO START.PLAY

PULL.THE.LEVER:
RECT 0,190,XLIMIT,YLIMIT, 0
PAYOUT = 0
MY.BONUS = 0
WILD.CARD.WIN = 0
CLS
GOSUB SHOW.POT.HEADER
GOSUB SHOW.BET.HEADER


GOSUB SETBLITWIDTH

## RESET CPU CLOCK
## EMULATOR ONLY !!!
##  POKE $9FB8,0

MAXSTOP = 0
MY.BONUS = 0
FOR I = 1 TO 3
    SLOT.STOP(I,1) = INT(RND(.)*51)+17
    SLOT.STOP(I,2) = INT(RND(1)*17)+1
    IF SLOT.STOP(I,1)>MAXSTOP THEN MAXSTOP = SLOT.STOP(I,1)
NEXT

WINNER.FLAG = (SLOT.STOP(1,2)=SLOT.STOP(2,2)) AND ( SLOT.STOP(2,2) = SLOT.STOP(3,2) )
IF WINNER.FLAG THEN SET.PAYOUT1

## TESTING CODE FOR COLOR.WIN
##  SLOT.STOP(1,2)=BANANA
##  SLOT.STOP(2,2)=LEMON
##  SLOT.STOP(3,2)=LEMON


COLOR.WIN = 0
COLOR.WIN = (FRUIT.COLORS%(SLOT.STOP(1,2)) = FRUIT.COLORS%(SLOT.STOP(2,2)))  AND (FRUIT.COLORS%(SLOT.STOP(2,2)) = FRUIT.COLORS%(SLOT.STOP(3,2)))
IF COLOR.WIN THEN MATCH.COLOR = FRUIT.COLORS%(SLOT.STOP(1,2)):GOTO SET.PAYOUT1


## TESTING CODE FOR WILD CARD WIN
##  SLOT.STOP(1,2) = COMMANDER
##  SLOT.STOP(2,2) = BAR
##  SLOT.STOP(3,2) = BAR

GOT.COMMANDER = 0
GOT.DIAMOND = 0
FOR I = 1 TO 3
 IF (SLOT.STOP(I,2) = COMMANDER) THEN GOT.COMMANDER = -1
 IF (SLOT.STOP(I,2) = DIAMOND) THEN GOT.DIAMOND = -1
NEXT I
THERE.IS.A.PAIR = (SLOT.STOP(1,2)=SLOT.STOP(2,2)) OR (SLOT.STOP(1,2)=SLOT.STOP(3,2)) OR (SLOT.STOP(2,2)=SLOT.STOP(3,2))

WILD.CARD.WIN = THERE.IS.A.PAIR AND GOT.COMMANDER

IF NOT WILD.CARD.WIN THEN SET.WINNER
   PAYOUT = -1
   PAY.MULT = 5
   MY.BONUS = 50000
   IF GOT.DIAMOND THEN PAY.MULT=PAY.MULT*2:MY.BONUS=MY.BONUS*2
   GOTO SKIP.WIN.SCHEME

SET.PAYOUT1:
 MY.BONUS = MY.BET
 PAYOUT = -1
 FRUIT = SLOT.STOP(1,2)
 IF COLOR.WIN THEN PAY.MULT = 0:MY.BONUS = 10000:IF FRUIT.COLORS%(FRUIT) = GOLD THEN MY.BONUS=30000
 IF COLOR.WIN THEN SKIP.WIN.SCHEME

 IF (FRUIT >=APPLE) AND (FRUIT<=GRAPES) THEN PAY.MULT = 1
 IF (FRUIT > GRAPES) AND (FRUIT < BELL) THEN PAY.MULT = 2
 IF (FRUIT > CHERRYS) AND (FRUIT < BAR) THEN PAY.MULT = 3
 IF (FRUIT > COIN) THEN PAY.MULT = 4
 IF (FRUIT = DIAMOND) THEN PAY.MULT = 8
 IF (FRUIT = COMMANDER) THEN PAY.MULT = 10
 GOTO SKIP.WIN.SCHEME


SET.WINNER:
  WINNER = INT(RND(.)*200)

IF WINNER < 140 THEN PAYOUT=0:GOTO SKIP.WIN.SCHEME

IF WINNER > 180 THEN STOPPER = INT(RND(1)*(COMMANDER -(BAR-1))) + BAR
IF WINNER > 180 THEN PAY.MULT = 4
IF (WINNER > 180) AND (STOPPER=DIAMOND) THEN PAY.MULT=8
IF (WINNER > 180) AND (STOPPER=COMMANDER) THEN PAY.MULT=10
IF WINNER > 180 THEN SET.STOPS

IF WINNER > 165 THEN STOPPER = INT(RND(1)*(COIN-(BELL-1)))+BELL
IF WINNER > 165 THEN PAY.MULT = 3:GOTO SET.STOPS

IF WINNER > 150 THEN STOPPER = INT(RND(1)*2)+HEART
IF WINNER > 150 THEN PAY.MULT = 2:GOTO SET.STOPS

STOPPER = INT(RND(1)*GRAPES)+APPLE
PAY.MULT = 1

SET.STOPS:
 PAYOUT = -1
 FOR REEL = 1 TO 3:SLOT.STOP(REEL,2)=STOPPER:NEXT

## Here we finish setting up for the Slot Reel Spin
SKIP.WIN.SCHEME:
## Set up the SPINNING X16 Logo
   SPININC=1:SPINTEST=17:SPINSET = 1
   IF INT(RND(.)*6)>3 THEN SPININC=-1:SPINTEST = 0:SPINSET = 16

## Set up a random start position for Each Slot Wheel
## So we see different pictures in each position
   FOR I=1 TO 3:SKIP(I)=0:SLOT.FRM(I) = INT(RND(.)*17)+1:NEXT I

## Count of Reels that have reached STOP
   S.CNT=0

## Y coord for graph_draw_image in BLITTER
   Y1 = 40

## Turn on the Wandering X16 Logo
   SPRITE X16.SPR, 2

## Used to determine whether of not to sound a "Bell"
## We want it to be "ON" when starting the spin
   DOBELL = -1

## Grab a Random Light Palette for the BLINKENLIGHTS
   PAL.RANDOM = 0
   GOSUB GET.PALETTE.POINTERS



## This is the MAIN Slot Reel Spin LOOP
## Some lines are compressed together because
## it helps us run a Little faster in interpreted BASIC
   FOR ROTATION = 1 TO MAXSTOP+34

       ## Loop through each "REEL"
       FOR REEL = 1 TO 3:DOBELL = (DOBELL + 1) AND 1:IF DOBELL=0 THEN SLEEP:FMDRUM  REEL, 51
         IF SKIP(REEL) THEN SLEEP S.CNT+1:GOTO SKIP.BLIT
           BUMP.FLAG=0:X1=SLOT.X(REEL):FRM = SLOT.FRM(REEL):IF DOBELL THEN FMDRUM REEL+2,BELL(INT(RND(.)*4)+1)
           IF ROTATION>SLOT.STOP(REEL,1) THEN IF SLOT.FRM(REEL)=SLOT.STOP(REEL,2) THEN SKIP(REEL)=-1:S.CNT = S.CNT+1:BUMP.FLAG=-1
           GOSUB SETBLITXY:IF BUMP.FLAG AND (S.CNT=3) THEN FMDRUM REEL+3,BELL(INT(RND(.)*4)+1):SL.D=3:GOSUB SLOW.BLITTER:GOTO NEXT.FRM
           GOSUB BLITTER
  NEXT.FRM:
           ## Sound when a Reel "Stops Spinning"
           IF BUMP.FLAG THEN FMDRUM 7,82

           ## Advance the Slot Reel
           SLOT.FRM(REEL)=SLOT.FRM(REEL)+1:IF SLOT.FRM(REEL)=18 THEN SLOT.FRM(REEL)=1
SKIP.BLIT:
          ## This is the Code for the "Spinning X16 Logo"
          SPRITE LASTSPRITE, 0:SPRITE SPINFRAMES(CURFRAME,1),3,0,SPINFRAMES(CURFRAME,2)
          LASTSPRITE = SPINFRAMES(CURFRAME,1):CURFRAME = CURFRAME + SPININC:IF CURFRAME = SPINTEST THEN CURFRAME = SPINSET

          ## IF THE X16 Logos are in motion already then skip this
          ## Otherwise setup the X16 logo's motion
          IF MOVING THEN SKIP.SETUP
             GOSUB GET.PALETTE.POINTERS
             SPININC=1:SPINTEST=17:SPINSET = 1:IF INT(RND(.)*6)>3 THEN SPININC=-1:SPINTEST = 0:SPINSET = 16
             OLDY = SY
             MOVING = -1:XSTART = INT(RND(.)*11)
             TRY.Y.AGAIN:
             SY = INT(RND(.) * 55)+155
             IF ABS(OLDY-SY)<12 THEN TRY.Y.AGAIN
             IF XSTART < 6 THEN SX = -32:SX.INC=5:XEND = XLIMIT:GOTO START.MOVE
             SX = XLIMIT+33:SX.INC=-5:XEND=-33
          START.MOVE:
             MOVSPR X16.SPR,SX,SY

          ## Continue Motion
          ## When past XEND then turn MOVING off and
          ## Do a "Coin Toss" on New motion
          SKIP.SETUP:
             SX = SX+SX.INC:MOVSPR X16.SPR, SX,SY:IF XEND < 0 THEN X16.FLIP = (SX < XEND):GOTO SET.MOVING
             X16.FLIP = (SX > XEND)
          SET.MOVING:
             MOVING = NOT X16.FLIP:PALINDX=PALINDX+1:IF PALINDX>5 THEN PALINDX=1

          ## Here we do the BLINKENLIGHT Palette Animation
          ## Then advance to the next "Slot Reel"
             GOSUB LOAD.ANIM.PAL:NEXT REEL

        ## Here we are done with all the "Slot Reels" so End Rotations
        IF S.CNT = 3 THEN ROTATION=MAXSTOP+35
  NEXT ROTATION
## End main "Slot Spin" Loop

BLOOPS = 1:BLINKLOOPS = 5:IF PAYOUT THEN BLINKLOOPS = 60:GOSUB RightX16Logo

## Move the wandering X16 Logo off screen in the direction
## It was last moving
  FOR ExitX = SX TO XEND STEP SX.INC
    MOVSPR X16.SPR,ExitX,SY
    PALINDX=PALINDX+1:IF PALINDX>5 THEN PALINDX=1
    GOSUB LOAD.ANIM.PAL
  NEXT ExitX


## Blink the lights real fast before turning them OFF
 DO.BLINKLOOP:
   GOSUB GET.PALETTE.POINTERS:GOSUB LOAD.ANIM.PAL
   BLOOPS = BLOOPS+1
   IF BLOOPS < BLINKLOOPS THEN DO.BLINKLOOP

## Turns OFF the BLINKENLIGHTS
  GOSUB LAST5.PALBLACK


SKIP.SPRITE:
  MOVING = 0
  SPRITE X16.SPR, 0
  FMVOL 7, 55
  IF NOT PAYOUT THEN GOSUB BANK.TAKES.THEMONEY
  IF PAYOUT THEN GOSUB DO.PAYOUT

  PAYOUT = 0
START.PLAY:
  COLOR 1,0
  RECT 6,192,313,237, $B4
  X1 = 6:Y1=192:X2=313:Y2=237:CC=$B9:CD=1:GOSUB DRAWFRAME

  LOCATE 26,4:PRINT "{WHT}[{LIGHT GREEN}";ARROWS$;"{WHT}] -{YEL} ${WHT}.25{GRN}/{YEL}${WHT}1";
  LOCATE 27,3:PRINT "{WHT}[{LIGHT GREEN}F10{WHT}] -{YEL} $ {WHT}10{LIGHT RED}.{WHT}00";
  LOCATE 26,23:PRINT "{WHT}[{LIGHT GREEN}F11{WHT}] -{YEL} ${WHT}100{LIGHT RED}.{WHT}00";
  LOCATE 27,23:PRINT "{WHT}[{LIGHT GREEN}F12{WHT}] -{YEL} ${WHT} ALL{YEL} $";
  LOCATE 29,3:PRINT "{WHT}[{LIGHT GREEN}SPACEBAR{WHT}] -{WHT} {GRN}Spin{YEL}!";
  LOCATE 29,23:PRINT "{WHT}[{LIGHT GREEN}ESC{WHT}] -{GRN} Cash Out";

## This loop will flush the Keyboard Buffer
  FOR I = 0 TO -1 STEP 0:GET X$:I=(X$=""):NEXT

GET.CHOICE:
  USER.QUIT=0
  FOR I = 0 TO -1 STEP 0:
    GET X$
## My Ctrl/C Handler pokes a 27 at $70 if
## Ctrl/C or BRK has been pressed
## The FlushBreak makes sure its not PERSISTENT
## So we just act like ESC has been pressed
## User wants to END
    IF PEEK($70)=27 THEN X$=CHR$(27):GOSUB FLUSHBREAK
    I=(X$<>"")
    IF I THEN SKIPALL
    TICK = TICK+1 AND $F
    COLOR 2
    IF TICK/2 = INT(TICK/2) THEN COLOR 10
    LOCATE 27,33:PRINT "ALL";
    SLEEP 3
    COLOR 13
    IF TICK/2 = INT(TICK/2) THEN COLOR 5
    LOCATE 27,24:PRINT "F12";
    SLEEP 3
SKIPALL:
  NEXT

   X=ASC(X$)
   IF X=135 THEN X=22
   IF X=139 THEN X=23
   MY.TOTAL = MY.BET + MY.POT
   IF X=21 THEN BET.INCREMENT = 1000:GOSUB DO.BET:GOTO GET.CHOICE
   IF X=22 THEN BET.INCREMENT = 10000:GOSUB DO.BET:GOTO GET.CHOICE
   IF X=23 THEN BET.INCREMENT = MY.POT:GOSUB DO.BET:GOTO GET.CHOICE
   IF X=27 THEN Y=7:QUIT.FLAG=-1:GOSUB ASK.2.QUIT:IF NOT USER.QUIT THEN GOTO GET.CHOICE
   IF X=20 OR X=157 THEN GOSUB REVERSE.THE.BET:GOTO GET.CHOICE
   IF USER.QUIT THEN DONE
   IF X=32 THEN PULL.THE.LEVER
   IF X=145 THEN GOSUB RAISE.BET:GOTO GET.CHOICE
   IF X=17 THEN GOSUB LOWER.BET:GOTO GET.CHOICE
   FMDRUM 2,87
  GOTO GET.CHOICE

RightX16Logo:
  FOR XLogo = 0 TO -1 STEP 0
   XLogo = (CURFRAME=1)
   SLEEP 1:SPRITE SPINFRAMES(CURFRAME,1),3,0,SPINFRAMES(CURFRAME,2):SLEEP:SPRITE LASTSPRITE, 0
   LASTSPRITE = SPINFRAMES(CURFRAME,1):CURFRAME = CURFRAME + SPININC:IF CURFRAME = SPINTEST THEN CURFRAME = SPINSET
  NEXT
RETURN


## This SUB sets up what Palette will be used
## for the BLINKENLIGHTS during spin
GET.PALETTE.POINTERS:
 ## Select Which Palette Set Randomly
  P = INT(RND(.)*18)+1

  ## DEBUG CODE
  ## LOCATE 2,2:PRINT "                       ";
  ## LOCATE 2,2:PRINT "PAL SET";P;"     ";

  ON P GOTO PALSET1,PALSET2,PALSET3,PALSET4,PALSET5,PALSET6,PALSET7,PALSET8,PALSET9,PALSET10,PALSET11,PALSET12,PALSET13,PALSET14,PALSET15,PALSET16,PALSET17,PALSET18
PALSET1:
  RESTORE PALPOINTER.SET1:GOTO PAL.LO.PAGE
PALSET2:
  RESTORE PALPOINTER.SET2:GOTO PAL.LO.PAGE
PALSET3:
  RESTORE PALPOINTER.SET3:GOTO PAL.LO.PAGE
PALSET4:
  RESTORE PALPOINTER.SET4:GOTO PAL.LO.PAGE
PALSET5:
  RESTORE PALPOINTER.SET5:GOTO PAL.LO.PAGE
PALSET6:
  RESTORE PALPOINTER.SET1:GOTO PAL.NXT.PAGE
PALSET7:
  RESTORE PALPOINTER.SET2:GOTO PAL.NXT.PAGE
PALSET8:
  RESTORE PALPOINTER.SET3:GOTO PAL.NXT.PAGE
PALSET9:
  RESTORE PALPOINTER.SET4:GOTO PAL.NXT.PAGE
PALSET10:
  RESTORE PALPOINTER.SET5:GOTO PAL.NXT.PAGE
PALSET11:
  RESTORE PALPOINTER.SET1:GOTO PAL.3RD.PAGE
PALSET12:
  RESTORE PALPOINTER.SET2:GOTO PAL.3RD.PAGE
PALSET13:
  RESTORE PALPOINTER.SET3:GOTO PAL.3RD.PAGE
PALSET14:
  RESTORE PALPOINTER.SET4:GOTO PAL.3RD.PAGE
PALSET15:
  RESTORE PALPOINTER.SET5:GOTO PAL.3RD.PAGE

## Two Extra RANDOM choices.  One pointing in my
## Palettes but NOT in order
## The other picks Random 10 byte chunks of RAM
## to load as a Palette, So
## Sometimes the BLINKENLIGHTS will be a little Crazy.

## Picks a RANDOM Index and RANDOM pointers
## into the prepared Palettes
PALSET16:
  PAL.HIGHPOINTER = $A0
  IF RND(.)*11 > 5 THEN PAL.HIGHPOINTER = $A1
  IF RND(.)*15 > 9 THEN PAL.HIGHPOINTER = $A2
  LOCATE 2,1
  FOR I = 1 TO 5
    PAL.PTRLO(I)=INT(RND(.)*256)
    ## PRINT HEX$(PAL.PTRLO(I))
  NEXT I
GOTO PALPTREND

## Picks 5 Random Pointers into the
## system Address Space to use as a Palette
PALSET17:
  PAL.HIGHPOINTER = INT(RND(.)*255)
  LOCATE 2,1
  FOR I = 1 TO 5
    PAL.PTRLO(I)=INT(RND(.)*245)+1
    ## PRINT HEX$(PAL.PTRLO(I))
  NEXT I
GOTO PALPTREND

## Uses the next Unused Memory Page in
## My High RAM Palette and
## Copys 50 entrys from the VERA Palette
## Starting at a Random Color Index
PALSET18:
  PAL.HIGHPOINTER = $A3
  PINDX = RND(.)*$D0
  PALADDR = PINDX*2 + $FA00

## Here I'm going from Number
## To HEX string and Back
## To seperate the Low and High
## Byte of a Pointer
  HADDR$ = HEX$(PALADDR)
  IF LEN(HADDR$)<4 THEN FOR A= 0 TO -1 STEP 0:HADDR$="0"+HADDR$:A=LEN(HADDR$)=4:NEXT
  HI$ = "$"+LEFT$(HADDR$,2)
  LO$ = "$"+RIGHT$(HADDR$,2)
  POKE $9F20, VAL(LO$)
  POKE $9F21, VAL(HI$)

  POKE $9F22,%00010001
  POKE R0L, $23
  POKE R0H, $9F
  POKE R1L, $00
  POKE R1H, $A3
  POKE R2H, 0
  POKE R2L, 50
  BANK 60
  SYS MEMORY.COPY
  RESTORE PALPOINTER.SET1
  GOTO ReadPalPointers

PAL.LO.PAGE:
  PAL.HIGHPOINTER = $A0:GOTO ReadPalPointers
PAL.NXT.PAGE:
  PAL.HIGHPOINTER = $A1:GOTO ReadPalPointers
PAL.3RD.PAGE:
  PAL.HIGHPOINTER = $A2
ReadPalPointers:
  FOR I = 1 TO 5:READ PAL.PTRLO(I):NEXT
PALPTREND:
  ## DEBUG CODE
  ## COLOR 1
  ## LOCATE 1,1:PRINT RPT$(32,30);
  ## LOCATE 1,1:PRINT "P:";P,"HIPTR: ";HEX$(PAL.HIGHPOINTER)
RETURN

REVERSE.THE.BET:
  IF MY.BET = 25 THEN FMDRUM 7,87:RETURN
  MY.POT = MY.TOTAL-25
  MY.BET = 25
  FMDRUM 7, 33
  GOSUB SHOW.POT.DOLLARS
## TAIL CALL ELIMINATION
## OPTIMIZATION.  RETURN FROM SHOW.BET.DOLLARS
GOTO SHOW.BET.DOLLARS

DONE:
 ## TURN OFF ALL THE SPRITES
  FOR S = 1 TO SPINSPRITE+4:SPRITE S,0:NEXT
 ## SWITCH TO SCREEN 0
  SCREEN 0
  BANNER
  PRINT:PRINT "{CR}THANK YOU FOR PLAYING SLOTS.":PRINT
  AMOUNT = MY.POT+MY.BET:GOSUB FORMAT.AMOUNT
  PRINT " {GREY 1}FINAL POT: ";D$;C$;
  PRINT "{CR}"
  PRINT " {WHT}RUN {YEL}- {GREY 1}TO DO IT AGAIN {WHT}!":PRINT

 SAFEEND:
  ## RESTORE ALL PALETTE CHANGES
  GOSUB SET.DEFAULT.PALETTE
## RESTORE DEFAULT BREAK HANDLER
  SYS $0656
END

DO.PAYOUT:
  DO.TRUMPET = (PAY.MULT>7) OR (INT(RND(.)*11)>6) OR ((PAY.MULT*MY.BET) > 120000) OR (MY.BONUS>50000)
  DO.CONGRATS = WILD.CARD.WIN OR (PAY.MULT=10) OR (INT(RND(.)*10)>6)
  IF DO.TRUMPET THEN AUDIOBANK = TRUMPETBANK:V.RATE=32:AUD.LOOPS=8:GOSUB PLAY.AUDIO
  IF DO.CONGRATS THEN AUDIOBANK = CONGRATSBANK:V.RATE=30:AUD.LOOPS=5:GOSUB PLAY.AUDIO
  IF WILD.CARD.WIN THEN LOCATE 22,5:PRINT "{PUR}X{LIGHT GREEN}1{LIGHT BLUE}6{WHT} WildCard Payout";
  IF COLOR.WIN THEN LOCATE 22,5:PRINT FRUIT.COLORS$(MATCH.COLOR);COLOR.NAME$(MATCH.COLOR)" {GREY 1}Color Match {WHT}Bonus {LIGHT GREEN}!";
  P$=STR$(PAY.MULT)
  P$=RIGHT$(P$,LEN(P$)-1)
  IF PAY.MULT>0 THEN LOCATE 23,5:PRINT "{WHT}";P$;"{LIGHT GREEN}x{GREY 1} Payout {YEL}";
  IF PAY.MULT=0 THEN LOCATE 23,5:PRINT "{GREY 1}You Kept your {WHT}Bet{GREY 1} Amount{LIGHT GREEN}:{YEL} ";
  AMOUNT = (MY.BET+(MY.BET * PAY.MULT)):GOSUB FORMAT.AMOUNT
  PRINT D$;C$;
  IF MY.BONUS > 0 THEN AMOUNT=MY.BONUS:GOSUB FORMAT.AMOUNT
  IF MY.BONUS > 0 THEN LOCATE 25,5:PRINT "{GREY 1}Bonus Payout: ";D$;C$;
  AMOUNT = (MY.BET+(MY.BET * PAY.MULT))
  MY.POT = (MY.POT + AMOUNT + MY.BONUS) - 25
  MY.BET = 25
  PAY.AUD.LOOPS = 3
  IF PAY.MULT = 10 THEN PAY.AUD.LOOPS = 6
  IF (PAY.MULT>4) AND (PAY.MULT<10) THEN PAY.AUD.LOOPS = 4
  IF PAY.MULT < 3 THEN PAY.AUD.LOOPS = PAY.MULT
  GOSUB PAYOUT.AUDIO
  GOSUB SHOW.BET.DOLLARS
  GOSUB SHOW.POT.DOLLARS
  GOSUB RAIN.COINS
  IF PAY.AUD.LOOPS<2 THEN PAY.DONE
  FOR V = 1 TO (PAY.AUD.LOOPS-1)
    GOSUB PAYOUT.AUDIO
  NEXT V
  IF PAY.AUD.LOOPS = 2 THEN PAY.DONE
  GOSUB RAIN.COINS
PAY.DONE:
  LOCATE 22,1:PRINT RPT$(32,38);
  LOCATE 23,1:PRINT RPT$(32,38);
  LOCATE 25,1:PRINT RPT$(32,38);
  PAYOUT = 0
RETURN

BANK.TAKES.THEMONEY:
  IF MY.POT < 25 THEN BUSTED
  MY.BET = 25
  MY.POT = MY.POT - 25
  GOSUB SHOW.POT.DOLLARS
GOTO SHOW.BET.DOLLARS

BUSTED:
  ## TURNOFF THE SPRITES
  FOR S = 1 TO SPINSPRITE+4:SPRITE S,0:NEXT
  SAVE.RED.GB = VPEEK(1,$FA04)
  SAVE.RED.R = VPEEK(1,$FA05)
  AUDIOBANK = OUCHBANK:V.RATE=27:AUD.LOOPS=4:GOSUB PLAY.AUDIO
  GOSUB PAL2BLACK.SLOW
  CLS
  RECT 0,0,319,239, $52
  X1 = 0
  Y1 = 0
  X2 = 319
  Y2 = 239
  CC = $1B
  CD = 1
  GOSUB DRAWFRAME
  GOSUB DRAWFRAME
  GOSUB SET.DEFAULT.PALETTE
  VPOKE 1,$FA04,$00
  VPOKE 1,$FA05,$F
  COLOR 2
  X = 5:Y = 4:DC$=CHR$($DB):UC=0
  WD$="Your":GOSUB BIGWORD
  X = 1:Y = 13:WD$="Broke":GOSUB BIGWORD
  Y=23:QUIT.FLAG=0:GOSUB ASK.2.QUIT
  VPOKE 1,$FA04,SAVE.RED.GB
  VPOKE 1,$FA05,SAVE.RED.R
  IF NOT (USER.QUIT) THEN GOSUB HIDEALL:BANK 0,PEEK(1):POKE $BFFE,DEVICE:CLS:CLR:BANK 0,PEEK(1):DEVICE=PEEK($BFFE):RESTART.TRUE=-1:GOTO RESTART.SLOTS
  SCREEN 0:BANNER
  PRINT
  PRINT "{CR}{CR}{GREY 1} BUSTED{CR}{CR} ENTER {WHT}RUN{GREY 1} TO PLAY MORE SLOTS {WHT}!{CR}"
GOTO SAFEEND



PAYOUT.AUDIO:
 AUDIOBANK=COINSBANK
 V.RATE=27
 AUD.LOOPS = 13

## PLAYS MONO 8 BIT AUDIO ON THE VERA PCM PROCESSOR
## AUDIO SAMPLE IS EXPECTED TO START AT $A000 IN AUDIOBANK AND BE EVENLY DIVISIBLE INTO 4K CHUNKS.
## THIS CAN BE ACHIEVED BY JUDICIOUS TWEAKING OF THE SAMPLE RATE AND PLAYBACK SPEED IN AUDACITY
## AUDIO MAY OR MAY NOT TRAVERSE MULTIPLE BANKS. IT IS EXPECTED TO BE AT LEAST 8K IN SIZE.
## V.RATE SHOULD BE >0 AND < 129 AND CONTROLS SAMPLE PLAYBACK RATE.
## AUD.LOOPS SHOULD BE (AUDIOSIZE IN BYTES/4096) - 1
## PLEASE CHECK THE VERA PROGRAMMERS REFERENCE TO UNDERSTAND THIS ROUTINE MORE THOUROUGHLY
PLAY.AUDIO:
  WORKBANK = AUDIOBANK
  ADDR.HI = $A0
  POKE R0L, 0
  POKE R0H, ADDR.HI
  POKE R1L, $3D
  POKE R1H, $9F
  POKE R2L, .
  POKE R2H, $10
  BANK WORKBANK
  POKE AUDIO.CTRL, $0B
  SYS MEMORY.COPY
  POKE AUDIO.Rate, V.RATE

  FOR K = 1 TO AUD.LOOPS
    IF ADDR.HI=$A0 THEN ADDR.HI=$B0:GOTO STARTPOKES
    ADDR.HI = $A0
    WORKBANK = WORKBANK+1
    BANK WORKBANK
   STARTPOKES:
    POKE R0L, .
    POKE R0H, ADDR.HI
    POKE R1L, $3D
    POKE R1H, $9F
    POKE R2L, .
    POKE R2H, $10
    FOR Z = 0 TO FIFO.EMPTY STEP 0: Z = (PEEK(AUDIO.Ctrl) AND FIFO.EMPTY):NEXT Z
    POKE Audio.Rate, 0
    SYS MEMORY.COPY
    POKE Audio.Rate, V.RATE
  NEXT K
  FOR Z = 0 TO FIFO.EMPTY STEP 0: Z = (PEEK(AUDIO.Ctrl) AND FIFO.EMPTY):NEXT Z
  POKE AUDIO.Rate, 0
RETURN

## A CLONE OF THE ABOVE BUT CHECKS FOR KEY PRESSES AND WILL
## ABORT ON ESC KEY.   ONLY USED ON THE INTRO AUDIO.
PLAY.AUDIO2:
  FOR Z=0 TO -1 STEP 0:GET X$:Z=(X$=""):NEXT
  WORKBANK = AUDIOBANK
  ADDR.HI = $A0
  POKE R0L, 0
  POKE R0H, ADDR.HI
  POKE R1L, $3D
  POKE R1H, $9F
  POKE R2L, .
  POKE R2H, $10
  BANK WORKBANK
  POKE AUDIO.CTRL, $0B
  SYS MEMORY.COPY
  POKE AUDIO.Rate, V.RATE
  FOR K = 1 TO AUD.LOOPS
    IF ADDR.HI=$A0 THEN ADDR.HI=$B0:GOTO STARTPOKES2
    ADDR.HI = $A0
    WORKBANK = WORKBANK+1
    BANK WORKBANK
STARTPOKES2:
    POKE R0L, .
    POKE R0H, ADDR.HI
    POKE R1L, $3D
    POKE R1H, $9F
    POKE R2L, .
    POKE R2H, $10
    FOR Z = 0 TO -1 STEP 0: Z = ((PEEK(AUDIO.Ctrl) AND FIFO.EMPTY) = FIFO.EMPTY):NEXT Z
    POKE Audio.Rate, 0
    SYS MEMORY.COPY
    POKE Audio.Rate, V.RATE
## THE GET AND THE COMPARISON ARE HERE BECAUSE THIS IS IMMEDIATELY AFTER FILLING THE FIFO
## WHEN WE HAVE THE MOST TIME TO DO OTHER PROCESSING BEFORE THE FIFO GOES EMPTY
    IF X$="{ESC}" THEN RETURN
    GET X$
 NEXT K
 FOR Z = 0 TO -1 STEP 0: Z = (PEEK(AUDIO.Ctrl) AND FIFO.EMPTY) = FIFO.EMPTY:NEXT Z
   POKE AUDIO.Rate, 0
RETURN

BLITTER:
  IMG.BANK = FRAME.ADDR(FRM,1)
  ADDR.LO = FRAME.ADDR(FRM,2)
  ADDR.HI = FRAME.ADDR(FRM,3)
  POKE R2L,ADDR.LO:POKE R2H, ADDR.HI
  BANK IMG.BANK
  SYS GRAPH.DRAW.IMAGE
RETURN

SLOW.BLITTER:
  POPX = X1:POPY = Y1:POPLINES = BLITLINES
  XS2 = X1+(BLITWIDTH-1)
  IMG.PTR.ADVANCE = BLITWIDTH * 4
  IMG.BANK = FRAME.ADDR(FRM,1)
  ADDR.LO = FRAME.ADDR(FRM,2)
  ADDR.HI = FRAME.ADDR(FRM,3)
  IMG.POINTER = (ADDR.HI*256) + ADDR.LO
  BLITLINES = 4:BLITLOOPS = POPLINES/4
  BANK IMG.BANK
  GOSUB SETBLITWIDTH
  FOR BLITS = 1 TO BLITLOOPS
    POKE R2L,ADDR.LO:POKE R2H, ADDR.HI
    SYS GRAPH.DRAW.IMAGE
    IMG.POINTER = IMG.POINTER + IMG.PTR.ADVANCE
    ADDR.HI = FN Hi.Byte(IMG.POINTER)
    ADDR.LO = FN Lo.Byte(IMG.POINTER)
    Y1=Y1+4
    IF BLITS<BLITLOOPS THEN RECT X1,Y1,XS2,Y1+2,$C5
    SLEEP SL.D
    GOSUB SETBLITXY
    GOSUB SETBLITWIDTH
  NEXT
  X1=POPX:Y1=POPY:BLITLINES=POPLINES
  GOSUB SETBLITXY
GOTO SETBLITWIDTH

SETBLITXY:
 POKE R0L, X1:POKE R0H, .:POKE R1L, Y1:POKE R1H,.:RETURN

LOAD.ANIM.PAL:
  POKE $9F20, $F8:POKE $9F21,$FB:POKE $9F22, %00010001:BANK 60
  POKE R0H, PAL.HIGHPOINTER:POKE R0L, PAL.PTRLO(PALINDX)
  POKE R1L, $23:POKE R1H, $9F:POKE R2L, $0A:POKE R2H,$0
  SYS MEM.COPY

SETBLITWIDTH:
  POKE R3L, BLITWIDTH:POKE R3H,.:POKE R4L, BLITLINES:POKE R4H,.:RETURN

RAIN.COINS:
  FOR S = 1 TO NUMCOINS
    SPRMEM S, 1,$3000,1
    IF INT(RND(.)*10)>6 THEN SPRMEM S,1,$3400,1
    SPR.X(S) = INT(RND(.)*286)+2
    MOVSPR S, SPR.X(S),SPR.Y.VALS%(0,S)
    SPRITE S, INT(RND(.)*2)+2
    SPR.DONE(S) = 0
  NEXT
  LASTY=0
  FOR YVAL = 0 TO CoinLoopStop
      FOR S = 1 TO NUMCOINS
        MOVSPR S, SPR.X(S), SPR.Y.VALS%(YVAL,S)
      NEXT S
  NEXT YVAL
  FOR I = 1 TO NUMCOINS:SPRITE I,0:NEXT
RETURN

LOWER.BET:
  IF MY.BET < (BET.INCREMENT+25) THEN FMDRUM 7,87:GOTO END.LBET
  IF ABS(TI - LASTTIME)<15 THEN BET.INCREMENT = 100
  LASTIME=TI
  MY.BET = MY.BET-BET.INCREMENT:MY.POT=MY.POT+BET.INCREMENT
  GOSUB SHOW.BET.DOLLARS
  FMDRUM 7, 33
END.LBET:
  BET.INCREMENT=25
  GOTO SHOW.POT.DOLLARS

RAISE.BET:
  IF MY.POT = 0 THEN FMDRUM 7,87:RETURN
  IF ABS(TI - LASTTIME)<15 THEN BET.INCREMENT = 100:GOTO DO.BET
  BET.INCREMENT = 25
DO.BET:
  IF MY.POT = 0 THEN FMDRUM 7,87:RETURN
  LASTTIME = TI
  MY.BET = MY.BET+BET.INCREMENT:MY.POT=MY.POT-BET.INCREMENT:IF MY.POT < 0 THEN MY.BET = MY.TOTAL:MY.POT = 0
SHOW.DOLLARS:
  GOSUB SHOW.BET.DOLLARS
  FMDRUM 7, 33

## TAIL CALL OPTIMIZATION
##   GOSUB SHOW.POT.DOLLARS
## RETURN
GOTO SHOW.POT.DOLLARS

SHOW.THE.POT:
 RECT 27,128,128,152,$52
 X1 = 25
 Y1 = 122
 X2 = 134
 Y2 = 157
 CC = $56
 CD = 1
 GOSUB DRAWFRAME
SHOW.POT.HEADER:
 COLOR 1,0
 LOCATE 17,4:PRINT "              ";
 LOCATE 18,4:PRINT "              ";
 LOCATE 17,5:PRINT "$${GRN} My Pot{WHT} $$  ";
SHOW.POT.DOLLARS:
 COLOR 7
 AMOUNT=MY.POT:GOSUB FORMAT.AMOUNT
 LOCATE 19,4:PRINT "              ";
 LOCATE 19,6
 IF MY.POT > 999999 THEN LOCATE 19,5
 PRINT D$;C$;
RETURN

SHOW.THE.BET:
  RECT 188,128,294,152,$52
  X1 = 186
  Y1 = 122
  X2 = 294
  Y2 = 157
  CC = $56
  CD = 1
  GOSUB DRAWFRAME

SHOW.BET.HEADER:
  COLOR 1,0
  LOCATE 17,25:PRINT "              ";
  LOCATE 18,25:PRINT "              ";
  LOCATE 17,25:PRINT "$${GRN} My BET{WHT} $$  ";

SHOW.BET.DOLLARS:
  COLOR 7
  AMOUNT = MY.BET:GOSUB FORMAT.AMOUNT
  LOCATE 19,26:PRINT "              ";
  LOCATE 19,26
  IF MY.BET > 999999 THEN LOCATE 19,25
  PRINT D$;C$;
RETURN

FORMAT.AMOUNT:
  D = INT(AMOUNT/100)
  C = AMOUNT - (D*100)
  S$=STR$(D)
  D$=MID$(S$,2,LEN(S$)-1)
  D$="{YEL}${LIGHT GREEN}"+D$
  S$=STR$(C)
  C$=MID$(S$,2,LEN(S$)-1)
  IF LEN(C$)<2 THEN C$="0"+C$
  C$="{LIGHT RED}.{LIGHT GREEN}"+C$
RETURN

## Makes Sure Ctrl/C isn't persistent
FLUSHBREAK:
 FOR I=-1 TO 0 STEP 0
    SLEEP:POKE A.REG,32
    SYS $FEC3
    SLEEP
    POKE $70, 0
    GET Z$
    SLEEP
 ## Make sure the Ctrl/C Handler hasn't
 ## Slipped in yet another ESC char
    I=(PEEK($70)=27)
 NEXT
 RETURN

FRAMESLOTS:
  X1 = 94:Y1 = 0:GOSUB SETBLITXY
  BLITWIDTH = 27:BLITLINES = 25:GOSUB SETBLITWIDTH
  POKE R2L,. :POKE R2H, $A0
  BANK HIGHBANK
  SYS GRAPH.DRAW.IMAGE
  CHAR 120,15,1,CHR$($0C)+"16"
##  REM CHAR 138,20,1,CHR$($0C)+CHR$($06)+CHR$($0B)+"Casino Slots"
  CHAR 136,20,4,CHR$($0C)+CHR$($06)+CHR$($0B)+"C"
  CHAR 145,20,14,CHR$($0C)+CHR$($06)+CHR$($0B)+"as"
  CHAR 161,20,5,CHR$($0C)+CHR$($06)+CHR$($0B)+"in"
  CHAR 174,20,7,CHR$($0C)+CHR$($06)+CHR$($0B)+"o S"
  CHAR 197,20,8,CHR$($0C)+CHR$($06)+CHR$($0B)+"lo"
  CHAR 209,20,2,CHR$($0C)+CHR$($06)+CHR$($0B)+"ts"


  RECT 31, 27, 288, 114,$52
  X1 = 25
  Y1 = 24
  X2 = 294
  Y2 = 118:CC=$1C:CD=2
  CC = $56
  CD = 1

  GOSUB DRAWFRAME
  RESTORE XPOSITIONS

  FOR Z = 1 TO 3
    READ X1
    X1=X1-6
    X2=X1+75
    Y1 = 34
    Y2 = 109
    CC=$1C:CD = 2
    GOSUB DRAWFRAME
  NEXT Z
RETURN

DRAWFRAME:
  FOR JJ=1 TO 6:FRAME X1,Y1,X2,Y2,CC:X1=X1+1:X2=X2-1:Y1=Y1+1:Y2=Y2-1:CC=CC-CD:NEXT JJ
RETURN

## Draws the "BLINKENLIGHTS" on the screen
## These are hidden except during "Spin"
## When they are Palette Animated
## Uses builtin BASIC "OVAL" routine when on
## r48.  Otherwise uses the Breshenham algorithm
## in the SUB "CCIRCLE"
BLINKENLIGHTS:
  IF ROM.VERSION < 48 THEN GOSUB SHOWALL
  XSTART = 4
  YSTART = 4
  LCOL(1) = $FC
  LCOL(2) = $FD
  LCOL(3) = $FE
  LCOL(4) = $FF
  OCOL = 4
  ICOL = 1
  FOR X = 28 TO 75 STEP 23
    XR = 319-(X+15)
    IF ROM.VERSION<48 THEN BAS.CIRCLE1
      OVAL X,4,X+15,18,LCOL(OCOL)
      OVAL X+2,6,X+13,16,LCOL(ICOL)
      OVAL XR,4,XR+15,18,LCOL(OCOL)
      OVAL XR+2,6,XR+13,16,LCOL(ICOL)
    GOTO NEXT.COLOR1
BAS.CIRCLE1:
    RA = 7:CC=LCOL(OCOL):CX = X+7:CY=11:GOSUB CCIRCLE
    RA = 5:CC=LCOL(ICOL):GOSUB CCIRCLE
    RA = 7:CC=LCOL(OCOL):CX = XR+7.5:GOSUB CCIRCLE
    RA = 5:CC=LCOL(ICOL):GOSUB CCIRCLE
NEXT.COLOR1:
    OCOL = OCOL - 1:IF OCOL = 0 THEN OCOL=4
    ICOL = ICOL + 1:IF ICOL = 5 THEN ICOL=1
  NEXT
  OCOL = 1
  ICOL = 4
  FOR Y = 4 TO 166 STEP 23
    IF ROM.VERSION<48 THEN BAS.CIRCLE2
       OVAL 5,Y,20,Y+14, LCOL(OCOL)
       OVAL 7,Y+2,18,Y+12,LCOL(ICOL)
       OVAL 298,Y,313,Y+14, LCOL(OCOL)
       OVAL 300,Y+2,311,Y+12,LCOL(ICOL)
    GOTO NEXT.COLOR2
BAS.CIRCLE2:
    RA = 7:CC=LCOL(OCOL):CX=11:CY=Y+7:GOSUB CCIRCLE
    RA = 5:CC=LCOL(ICOL):GOSUB CCIRCLE
    RA = 7:CC=LCOL(OCOL):CX=307:CY=Y+7:GOSUB CCIRCLE
    RA = 5:CC=LCOL(ICOL):GOSUB CCIRCLE
NEXT.COLOR2:
    ICOL = ICOL - 1:IF ICOL = 0 THEN ICOL = 4
    OCOL = OCOL + 1:IF OCOL = 5 THEN OCOL = 1
  NEXT

  FOR X = 28 TO 126 STEP 23
    XR = 319-(X+15)
    IF ROM.VERSION<48 THEN BAS.CIRCLE3
     OVAL X,165,X+15,179, LCOL(OCOL)
     OVAL X+2,167,X+13,177,LCOL(ICOL)
     OVAL XR,165,XR+15,179,LCOL(OCOL)
     OVAL XR+2,167,XR+13,177,LCOL(ICOL)
    GOTO NEXT.COLORS3
BAS.CIRCLE3:
    RA = 7:CC=LCOL(OCOL):CX = X+7:CY=172:GOSUB CCIRCLE
    RA = 5:CC=LCOL(ICOL):GOSUB CCIRCLE
    RA = 7:CC=LCOL(OCOL):CX = XR+7.5:GOSUB CCIRCLE
    RA = 5:CC=LCOL(ICOL):GOSUB CCIRCLE
NEXT.COLORS3:
    ICOL = ICOL - 1:IF ICOL = 0 THEN ICOL = 4
    OCOL = OCOL + 1:IF OCOL = 5 THEN OCOL = 1
  NEXT

## After drawing all the Circles
## Now draw the "Triangle"
  X1 = 143:Y1=165:X2=177:Y2=181:RC =INT(RND(.)*3)+251
  ColorFlip = 0
  FOR I = 0 TO -1 STEP 0
      IF X1<>X2 THEN X1=X1+1:X2=X2-1
      IF Y1<>Y2 THEN Y1=Y1+1:REM Y2=Y2-1
      ColorFlip = ColorFlip+1
      LINE X1,Y1,X2,Y1,RC
      IF ColorFlip/2 = INT(ColorFlip/2) THEN RC=RC+1:IF RC=256 THEN RC=252:
      I = (X1>=X2) OR (Y1=Y2)
  NEXT

RETURN

## Substitute Breshenham Circle for r47
CCIRCLE:
     C3=RA:G=0:C4=2*(1-RA):W=2.6
     FOR ZX = 0 TO -1 STEP 0
       LINE CX-G,CY-C3,CX+G,CY-C3,CC
       LINE CX-G,CY+C3,CX+G,CY+C3,CC
       IF (C4+RA)>0 THEN C3=C3-1:C4=C4-W*C3-1
       IF G>C4 THEN G=G+1: C4=C4+2*G+1
       ZX=(C3<0)
     NEXT ZX:RETURN

## This sub loads all the file assets
## And sets up the Image and Audio Pointers
LOADFRAMES:
##  LOAD THE SMALL X16 IMAGE TO GOLDEN RAM
##   BLOAD "XSMALL.BIN",DEVICE,63,$0400

## LOAD THE SLOT REEL IMAGES STARTING IN HI RAM BANK 2
  IMG.BANK=2
  BLOAD "SLOT.IMAGES",DEVICE,IMG.BANK,$A000
## SET IMAGE POINTER ARRAY.
  FOR SLOTS = 1 TO 17
    ADDR.HI = $A0
    IF SLOTS/2 = INT(SLOTS/2) THEN ADDR.HI=$B0
    FRAME.ADDR(SLOTS,1) = IMG.BANK
    FRAME.ADDR(SLOTS,2) = 0
    FRAME.ADDR(SLOTS,3) = ADDR.HI
## Each SLOT REEL Image is EXACTLY 4k in Size
## 2 in each bank.  So Every 2nd Image we advance Hi.Ram bank
    IF SLOTS/2 = INT(SLOTS/2) THEN IMG.BANK=IMG.BANK+1
  NEXT SLOTS
  IMG.BANK=2

## LOAD THE COIN DROPPING AUDIO
## Load to the Next Bank after current (peek(0))
  COINSBANK = PEEK(0)+1
    BLOAD "COINS.AUD",DEVICE,COINSBANK,$A000

## LOAD THE "BUSTED" AUDIO
  OUCHBANK = PEEK(0)+1
    BLOAD "OUCH.AUD",DEVICE,OUCHBANK,$A000
  CONGRATSBANK = PEEK(0)+1
    BLOAD "CONGRATS.AUD",DEVICE,CONGRATSBANK,$A000

  TRUMPETBANK = PEEK(0)+1
    BLOAD "TRUMPETS.AUD",DEVICE,TRUMPETBANK,$A000
   HIGHBANK = PEEK(0)+1

## LOAD THE SMALL X16 IMAGE TO HIGHBANK
   BLOAD "XSMALL.BIN",DEVICE,HIGHBANK,$A000



   ## INFORMATION CODE FOR ASSET LOADING
    ## GOSUB SHOWTEXT
    ## LOCATE 1,1
    ## PRINT " HIGHBANK:";HIGHBANK;
    ## SLEEP 120

## LOAD THE IMAGE FOR THE "COIN" SPRITE
  BVLOAD "COIN.SPR",DEVICE,1,$3000

## AND SETUP THE "COIN SPRITES" TO POINT AT THAT IMAGE
  FOR S = 1 TO NUMCOINS
      SPRMEM S, 1,$3000,1
      SPRITE S,0,0,0,2,2,1
  NEXT

## LOAD THE IMAGE FOR THE X16 SPRITE
  BVLOAD "X16-32P.BIN",DEVICE,1,$3400
  X16.SPR = NUMCOINS + 1
  SPRMEM X16.SPR,1,$3400,1
  SPRITE X16.SPR,0,0,0,2,2,1

BVLOAD "X16.0.BIN",DEVICE,1,$3800
BVLOAD "X16.22.BIN",DEVICE,1,$4800
BVLOAD "X16.45.BIN",DEVICE,1,$5800
BVLOAD "X16.67.BIN",DEVICE,1,$6800
BVLOAD "X16.90.BIN",DEVICE,1,$7800

SPINSPRITE = X16.SPR + 1

SPRMEM SPINSPRITE,1,$3800,1
SPRMEM SPINSPRITE+1,1,$4800,1
SPRMEM SPINSPRITE+2,1,$5800,1
SPRMEM SPINSPRITE+3,1,$6800,1
SPRMEM SPINSPRITE+4,1,$7800,1

FOR S = 0 TO 4
  MOVSPR S+SPINSPRITE,129 ,111
  SPRITE S+SPINSPRITE, 0,0,0,3,3
NEXT


## SET THE X POSITIONS WHERE TO BLIT THE IMAGES.
  RESTORE XPOSITIONS
    FOR I=1 TO 3:READ SLOT.X(I):NEXT
RETURN

ASK.2.QUIT:
 QY = Y+2
 USER.QUIT=0:GOSUB VMsgBox:LOCATE QY,10:PRINT "{LIGHT GREEN}QUIT ";:PRINT "{GRN}X16 Slots{LIGHT GREEN}?";
 YY=QY:YX=32
 GOSUB GET.Yes.No:DO.QUIT=YES%:USER.QUIT=DO.QUIT


## TextBox is a general purpose routine to draw a BOX
## Using Characters loaded in the DChar Array.
## The two routines below are preconfigured to draw
## The text Box I need for this program. Y is set
## Before calling
ClrMsgBox:
 COLOR 0,0:GOTO BOX.SKIP.COLOR

VMsgBox:
 COLOR 2,11
BOX.SKIP.COLOR:
 X=8:H=5:W=27

TEXTBOX:
  LOCATE Y,X:PRINT CHR$(DChars%(1));RPT$(DChars%(2),W-2);CHR$(DChars%(3));
  IF H=2 THEN SKIPMID
  BStart=Y+1:BEnd=Y+(H-2)
  FOR Y2 = BStart TO BEnd:LOCATE Y2,X:PRINT CHR$(DChars%(4));RPT$(32,W-2);CHR$(DChars%(5));:NEXT
SKIPMID:
  LOCATE Y+H-1,X:PRINT CHR$(DChars%(6));RPT$(DChars%(7),W-2);CHR$(DChars%(8));:RETURN

GET.Yes.No:
 LOCATE YY, YX-6:PRINT "{WHT}({YEL}Y{LIGHT GREEN}/{YEL}N{WHT})";
 GOTIT = FALSE:COLOR 1, 6:LOCATE YY, YX:PRINT "{WHT} ";
GETIT:
 GET X$:IF X$="" THEN GETIT
 IF QUIT.FLAG THEN IF X$="{ESC}" THEN GOTIT=TRUE:Q$="N":X$="{CR}"
 IF X$="y" THEN X$="Y"
 IF X$="n" THEN X$="N"
 IF X$<>"Y" AND X$<>"N" AND X$<>"{CR}" THEN FMDRUM 7,59
 IF X$="Y" THEN FMDRUM 7,55
 IF X$="N" THEN FMDRUM 7,33
 IF X$="Y" OR X$="N" THEN GOTIT = TRUE:Q$=X$:LOCATE YY,YX:PRINT X$;
 IF X$<>"{CR}" OR NOT (GOTIT) THEN GETIT
 YES% = (Q$="Y"):RETURN


## Draws a BIGWORD using CHR DC$ as the "PIXEL"
## Peeks the system ROM font in Bank 6 to do this
## WORD to DRAW passed in WD$
## LOCATION to Start Draw passed in X,Y
## WILL CRASH WITH ILLEGAL FUNCTION CALL ON THE LOCATE
## IF IT DOESN'T FIT ON THE CURRENT SCREEN!!!
BIGWORD:
  L=LEN(WD$):SX=X
  OB=PEEK(1):BANK PEEK(0),6
  FOR K=1 TO L
    CC=ASC(MID$(WD$,K,1))
    IF (CC>=64 AND CC<=90) THEN AA=64:GOTO SKIP0
    IF (CC>=97 AND CC<=122) THEN AA=-32:GOTO SKIP0
    AA=0
SKIP0:
    REM CA=$C000+8*(CC-AA):REM THICKFONT Address in ROM
    CA=$D000+8*(CC-AA):REM THINFONT Address in ROM
    FOR I=1 TO 8
      CM(I)=PEEK(CA+(I-1)):CM$(I)=""
    NEXT I
    IF DC$="" THEN DC$=CHR$(CC)
    TD=8:IF CC=32 THEN TD=4
    FOR J=1 TO TD
        FOR CT=1 TO 8
            IF (BIT.MASK(CT) AND CM(J)) THEN CM$(J)=CM$(J)+DC$:GOTO SKIPSPC
            CM$(J)=CM$(J)+CHR$(32)
      SKIPSPC:
        NEXT CT
        LOCATE Y+(J-1),X:IF UC=1 THEN COLOR TC%(1,J),TC%(2,J)
        PRINT CM$(J);
    NEXT J
    IF DC$=CHR$(CC) THEN DC$=""
    X=X+TD
  NEXT K
  X=SX:BANK PEEK(0),OB:RETURN

## Load the Draw Chars array for TEXTBOX GOSUB
LoadDCharsCP437:
  RESTORE CP437DRAW:FOR I=1 TO 8:READ DChars%(I):Next
RETURN

## LOADS AN 8bpp BMX Image Centered on the Screen
## SCREEN $80 must be set prior to call.
## BMX image name passed in F$, Hi RAM Bank to
## USE will be passed in GRAPH.BANK.
## GRAPH.BANK MUST be initialized.
## LOADING THE BMX to BANK 0 IS BAD !!!!!
LOADBMX2:
## Hide the graphics layer
  GOSUB HIDEGRAPHICS

## Allocate space for the BMX Header
  BMX.HDR$=RPT$(32,32)

## Load the whole BMX file to HIRAM at GRAPH.BANK
  BLOAD F$,DEVICE,GRAPH.BANK,$A000

## Switch to that Bank
  BANK GRAPH.BANK

## Copy the Header to the BMX.HDR$ variable.
  P=POINTER(BMX.HDR$)
  POKE R0L, .
  POKE R0H, $A0
  POKE R1L, PEEK(P+1)
  POKE R1H, PEEK(P+2)
  POKE R2L, 32
  POKE R2H, .
  SYS MEM.COPY

## Parse the Header
  GOSUB PARSEHEADER

## Stuff to check for a VALID BMX file.
  IF BMX.ID$<>"BMX" THEN ERRMSG$= RED$+F$+WHITE$+" IS NOT A BMX FILE":GOTO ERR.EXIT
  IF BMX.BITS<>8 THEN ERRMSG$= RED$+STR$(BMX.BITS)+WHITE$+" BITS NOT SUPPORTED":GOTO ERR.EXIT
  IF BMX.VER<>1 THEN ERRMSG$= RED$+F$+WHITE$+" IS VERSION:";+RED$+STR$(BMX.VER)+WHITE$+" NOT SUPPORTED!":GOTO ERR.EXIT
  IF BMX.WIDTH > 320 THEN ERRMSG$= RED$+STR$(BMX.WIDTH)+WHITE$+" WIDTH NOT CURRENTLY SUPPORTED":GOTO ERR.EXIT

## Parse and load the BMX Palette to VERA
  PALSIZE=BMX.PALUSED*2
  POKE R2L, (PALSIZE) AND $FF
  POKE R2H,INT((PALSIZE) / 256)
  TargetPal=$FA00+(BMX.FIRSTPAL*2)
  POKE $9F20, FN SW(TargetPal) AND $00FF
  POKE $9F21, INT(TargetPal/256)
  POKE $9F22, %00010001
  POKE R1L, $23
  POKE R1H, $9F
  POKE R0L, 32
  POKE ROH, $A0
  SYS MEM.COPY

## Get the pointer to the Image Data in the BMX file
  Image.Pointer = $A000+BMX.FILE.OFFSET

## Check the Image dimensions and CENTER on
## The 320x240 graphics SCREEN
  Y1=((240)-BMX.HEIGHT)/2
  IF Y1<. THEN Y1=.
  X1=((320)-BMX.WIDTH)/2
  POKE R0L,X1
  POKE R0H, .
  POKE R1L,Y1
  POKE R1H, .
  POKE R2L, FN SW(Image.Pointer) AND $FF
  POKE R2H, INT(Image.Pointer/256)
  POKE R3H, .
  IF BMX.WIDTH>$FF THEN POKE R3H, 1
  POKE R3L, BMX.WIDTH AND $FF
  POKE R4H, .
  IF BMX.HEIGHT>240 THEN POKE R4L, 240:SYS GRAPH.DRAW.IMAGE:RETURN
  POKE R4L, BMX.HEIGHT

## Blit the Image and then show the graphics layer
## This LOADBMX requires r47 and higher.
## prior to r47 graph_draw_image WAS NOT Bank Aware.
## I have another version that works on prior ROM's
  SYS GRAPH.DRAW.IMAGE

## Tail Call optimization
GOTO SHOWGRAPHICS
## GOSUB SHOWGRAPHICS
## RETURN

ERR.EXIT:
  GOSUB SHOWGRAPHICS
  PRINT:PRINT " ";ERRMSG$:WASERROR=-1:RETURN

## Parse the BMX Header after loading
PARSEHEADER:
    BMX.ID$=LEFT$(BMX.HDR$,3)
    BMX.VER=ASC(MID$(BMX.HDR$,4,1))
    BMX.BITS = ASC(MID$(BMX.HDR$,5,1))
    BMX.VERA.REG=ASC(MID$(BMX.HDR$,6,1))
    BMX.WIDTH = ASC(MID$(BMX.HDR$,7,1)) + (ASC(MID$(BMX.HDR$,8,1))*256)
   BMX.HEIGHT = ASC(MID$(BMX.HDR$,9,1)) + (ASC(MID$(BMX.HDR$,10,1))*256)
   BMX.PALUSED = ASC(MID$(BMX.HDR$,11,1)):IF BMX.PALUSED=. THEN BMX.PALUSED=256
   BMX.FIRSTPAL = ASC(MID$(BMX.HDR$,12,1))
   BMX.FILE.OFFSET = ASC(MID$(BMX.HDR$,13,1))+(ASC(MID$(BMX.HDR$,14,1))*256)
   BMX.COMPRESS= ASC(MID$(BMX.HDR$,15,1))
RETURN

## Does the "FANCY" Clear of the Intro Graphic.
ALTLINEWIPE:
   FOR Y = 0 TO YLIMIT STEP 4
       LINE 0,Y,XLIMIT,Y,0
       FOR D=1 TO J:NEXT D
   NEXT Y
   FOR Y = YLIMIT TO 0 STEP -3
       LINE 0,Y,XLIMIT,Y,0
       FOR D=1 TO J:NEXT D
   NEXT Y
   FOR Y = 0 TO YLIMIT STEP 2
       LINE 0,Y,XLIMIT,Y,0
       FOR D=1 TO J:NEXT D
   NEXT Y
   FOR Y = YLIMIT TO 0 STEP -2
       LINE 0,Y,XLIMIT,Y,0
       FOR D=1 TO J:NEXT D
   NEXT Y
RETURN


## Hide Text & Graphics Layers
HIDEALL:
  GOSUB HIDEGRAPHICS:GOTO HIDETEXT

## Show Text & Graphics Layers
SHOWALL:
  GOSUB SHOWGRAPHICS:GOTO SHOWTEXT

## Hide the Graphics Layer
HIDEGRAPHICS:
  POKE VERA.DCVIDEO, PEEK(VERA.DCVIDEO) AND LAYER0.OFF:RETURN

## Show the Graphics Layer
SHOWGRAPHICS:
  POKE VERA.DCVIDEO, PEEK(VERA.DCVIDEO) OR LAYER0.ON:RETURN

## Hide the Text Layer
HIDETEXT:
  POKE VERA.DCVIDEO, PEEK(VERA.DCVIDEO) AND LAYER1.OFF:RETURN

## Set the Text Layer Visible
SHOWTEXT:
  POKE VERA.DCVIDEO, PEEK(VERA.DCVIDEO) OR LAYER1.ON:RETURN


## Sets colors 251 - 255 to Black
## These Colors are used for the BLINKENLIGHTS
LAST5.PALBLACK:
  POKE R1L, $0A
  POKE R1H, .
  POKE $9F20, $F6
  POKE $9F21, $FB
  GOTO DO.PALBLACK

## Set the whole VERA Palette to BLACK.
PAL2BLACK:
  POKE R1L, 0
  POKE R1H, 2
  POKE $9F20, 0
  POKE $9F21, $FA
DO.PALBLACK:
  POKE $9F22, %00010001
  POKE R0L, $23
  POKE R0H, $9F
  POKE A.REG, 0
  SYS MEM.FILL
RETURN

PAL2BLACK.SLOW:
  FOR P = $FA00 TO $FBFF
     VPOKE 1, P, 0
  NEXT
RETURN

SET.DEFAULT.PALETTE:
  BVLOAD "DPAL.BIN",DEVICE,1,$FA00
RETURN

SetBrownToGold:
 GoldAddr = $FA00 + ($50*2)
 BrownAddr = $FA00 + (18)
 GB = VPEEK(1, GoldAddr)
 R = VPEEK(1,GoldAddr+1)
 VPOKE 1, BrownAddr, GB
 VPOKE 1, BrownAddr+1, R
RETURN

## SET UP MY NECESSARY PSEUDO CONSTANTS
## NECESSARY BEFORE CALLS THAT USE THE ROM
SETREGVARS:
  A.REG=$30C
  X.REG=$30D
  Y.REG=$30E
  C.REG=$30F
  R0L=2:R0H=3:R0=R0L
  R1L=4:R1H=5:R1=R1L
  R2L=6:R2H=7:R2=R2L
  R3L=8:R3H=9:R3=R3L
  R4L=10:R4H=11:R4=R4L
  R15L=$20:R15H=$21:R15=R15L
  CHKOUT=$FFC9:CHKIN=$FFC6
  CLRCHN=$FFCC
  MCIOUT=$FEB1:MACPTR=$FF44
  GRAPH.DRAW.IMAGE=$FF38
  FB.CURSOR.POSITION=$FEFF
  FB.CURSOR.NEXTLINE=$FF02
  TRUE=-1:FALSE=0
  AUDIO.Ctrl=$9F3B
  AUDIO.Rate=$9F3C
  AUDIO.FIFO=$9F3D
  FIFO.EMPTY = $40
  AFLOW = %00001000
  FIFO.FULL = $80
  MEM.COPY = $FEE7:MEMORY.COPY = MEM.COPY:
  MEM.FILL = $FEE4
  VERA.DCVIDEO=$9F29
  LAYER0.ON=16
  LAYER0.OFF=239
  LAYER1.ON=32
  LAYER1.OFF=223
  XLIMIT = 319
  YLIMIT = 239
RETURN

CHECK.FOR.NECESSARY.FILE.ASSETS:
  COLOR 1,0:CLS
  PRINT "{CR} CHECKING FOR NECESSARY ASSETS{CR}"
  RESTORE MY.ASSETS
  OK = 0
  ALL.DONE = 0
  FOR CheckAsset = 0 TO -1 STEP 0
      READ F$
      ALL.DONE = (F$="DONE")
      IF NOT ALL.DONE THEN GOSUB FILEEXISTS
      OK = FE% AND (NOT ALL.DONE)
      IF OK THEN PRINT "{GRN}   FOUND: {WHT}";F$
      IF NOT (ALL.DONE) AND (NOT OK) THEN PRINT CHR$(7);"{CR}{CR}{CR}{YEL}    MISSING : {LIGHT RED}";F$;"{WHT} !!":PRINT:PRINT CHR$(7):END
      CheckAsset = ALL.DONE
  NEXT
RETURN

MY.ASSETS:
 DATA "DPAL.BIN","COINS.AUD","CONGRATS.AUD","INTRO.AUD","TRUMPETS.AUD","OUCH.AUD","SLOT.IMAGES","SLOTS.FONT","SPLASH.BMX","COIN.SPR"
 DATA "X16.0.BIN","X16.22.BIN","X16.45.BIN","X16.67.BIN","X16.90.BIN","X16-32P.BIN","XSMALL.BIN","DONE"

FILEEXISTS:
  OPEN 2,DEVICE,2,F$+",S,R":CLOSE 2
  GOSUB GETFILECODE
  FE%=(FCode<=20):RETURN

DOS.CMD:
 OPEN 15,DEVICE,15, COMMAND$
 GOTO GETFCODE

GETFILECODE:
  OPEN 15,DEVICE,15
GETFCODE:
  INPUT#15,FCode,FC$,A,B:CLOSE 15:RETURN

LOAD.THE.ANIMATION.PALETTE:
  BANK 60
  P.Pointer = $A000
  RESTORE AnimationPalette
  FOR I = 0 TO 761
    READ C
    POKE P.Pointer, C
    P.Pointer = P.Pointer + 1
  NEXT
RETURN

## Starts at $A000 in the BANK
AnimationPalette:
 DATA $00,$04,$00,$08,$00,$0C,$00,$0F,$D6,$0E
 DATA $D6,$0E,$00,$04,$00,$08,$00,$0C,$00,$0F
 DATA $00,$0F,$D6,$0E,$00,$04,$00,$08,$00,$0C
 DATA $00,$0C,$00,$0F,$D6,$0E,$00,$04,$00,$08
 DATA $00,$08,$00,$0C,$00,$0F,$D6,$0E,$00,$04

 DATA $00,$0E,$00,$0D,$EE,$0E,$0E,$00,$0F,$00
 DATA $0F,$00,$00,$0E,$00,$0D,$EE,$0E,$0E,$00
 DATA $0E,$00,$0F,$00,$00,$0E,$00,$0D,$EE,$0E
 DATA $EE,$0E,$0E,$00,$0F,$00,$00,$0E,$00,$0D
 DATA $00,$0D,$EE,$0E,$0E,$00,$0F,$00,$00,$0E

 DATA $3F,$00,$3C,$00,$2A,$00,$28,$00,$16,$00
 DATA $16,$00,$3F,$00,$3C,$00,$2A,$00,$28,$00
 DATA $28,$00,$16,$00,$3F,$00,$3C,$00,$2A,$00
 DATA $2A,$00,$28,$00,$16,$00,$3F,$00,$3C,$00
 DATA $3C,$00,$2A,$00,$28,$00,$16,$00,$3F,$00

 DATA $FF,$0F,$CC,$0C,$99,$09,$66,$06,$33,$03
 DATA $33,$03,$FF,$0F,$CC,$0C,$99,$09,$66,$06
 DATA $66,$06,$33,$03,$FF,$0F,$CC,$0C,$99,$09
 DATA $99,$09,$66,$06,$33,$03,$FF,$0F,$CC,$0C
 DATA $CC,$0C,$99,$09,$66,$06,$33,$03,$FF,$0F

 DATA $C3,$0F,$F6,$03,$00,$0F,$F0,$07,$86,$06
 DATA $86,$06,$C3,$0F,$F6,$03,$00,$0F,$F0,$07
 DATA $F0,$07,$86,$06,$C3,$0F,$F6,$03,$00,$0F
 DATA $00,$0F,$F0,$07,$86,$06,$C3,$0F,$F6,$03
 DATA $F6,$03,$00,$0F,$F0,$07,$86,$06,$C3,$0F

 ## This Data fills the rest of a "Page".
## This allows me to use only 5 Lo Pointer sets
## For up to 5 Palette sets in a Page
## That will ALL use the SAME Hi byte for the Pointer
PAD:
 DATA 0,8,0,10,0,0

## Second Page $A1xx page
 DATA $F3,$09,$C3,$08,$A2,$06,$82,$05,$61,$04
 DATA $61,$04,$F3,$09,$C3,$08,$A2,$06,$82,$05
 DATA $82,$05,$61,$04,$F3,$09,$C3,$08,$A2,$06
 DATA $A2,$06,$82,$05,$61,$04,$F3,$09,$C3,$08
 DATA $C3,$08,$A2,$06,$82,$05,$61,$04,$F3,$09

 DATA $40,$06,$60,$08,$80,$0A,$90,$0C,$B0,$0F
 DATA $B0,$0F,$40,$06,$60,$08,$80,$0A,$90,$0C
 DATA $90,$0C,$B0,$0F,$40,$06,$60,$08,$80,$0A
 DATA $80,$0A,$90,$0C,$B0,$0F,$40,$06,$60,$08
 DATA $60,$08,$80,$0A,$90,$0C,$B0,$0F,$40,$06

 DATA $BB,$0C,$34,$0A,$C5,$0E,$64,$0A,$C3,$0F
 DATA $C3,$0F,$BB,$0C,$34,$0A,$C5,$0E,$64,$0A
 DATA $64,$0A,$C3,$0F,$BB,$0C,$34,$0A,$C5,$0E
 DATA $C5,$0E,$64,$0A,$C3,$0F,$BB,$0C,$34,$0A
 DATA $34,$0A,$C5,$0E,$64,$0A,$C3,$0F,$BB,$0C

 DATA $F2,$01,$30,$01,$F3,$02,$20,$00,$E0,$02
 DATA $E0,$02,$F2,$01,$30,$01,$F3,$02,$20,$00
 DATA $20,$00,$E0,$02,$F2,$01,$30,$01,$F3,$02
 DATA $F3,$02,$20,$00,$E0,$02,$F2,$01,$30,$01
 DATA $30,$01,$F3,$02,$20,$00,$E0,$02,$F2,$01

 DATA $E7,$0E,$0A,$00,$C5,$00,$4C,$0C,$FE,$0A
 DATA $00,$08,$E7,$0E,$0A,$00,$C5,$00,$4C,$0C
 DATA $FE,$0A,$00,$08,$E7,$0E,$0A,$00,$C5,$00
 DATA $4C,$0C,$FE,$0A,$00,$08,$E7,$0E,$0A,$00
 DATA $C5,$00,$4C,$0C,$FE,$0A,$00,$08,$E7,$0E

## PAD DATA FOR PAGE $A1
 DATA 0,$C,0,4,0,0

## START PAGE $A2
 DATA $3C,$0F,$3A,$0C,$28,$0A,$26,$08,$15,$06
 DATA $15,$06,$3C,$0F,$3A,$0C,$28,$0A,$26,$08
 DATA $26,$08,$15,$06,$3C,$0F,$3A,$0C,$28,$0A
 DATA $28,$0A,$26,$08,$15,$06,$3C,$0F,$3A,$0C
 DATA $3A,$0C,$28,$0A,$26,$08,$15,$06,$3C,$0F

 DATA $3F,$09,$3C,$08,$2A,$06,$28,$05,$16,$04
 DATA $16,$04,$3F,$09,$3C,$08,$2A,$06,$28,$05
 DATA $28,$05,$16,$04,$3F,$09,$3C,$08,$2A,$06
 DATA $2A,$06,$28,$05,$16,$04,$3F,$09,$3C,$08
 DATA $3C,$08,$2A,$06,$28,$05,$16,$04,$3F,$09

 DATA $02,$0F,$01,$05,$12,$0F,$11,$04,$01,$0D
 DATA $01,$0D,$02,$0F,$01,$05,$12,$0F,$11,$04
 DATA $11,$04,$01,$0D,$02,$0F,$01,$05,$12,$0F
 DATA $12,$0F,$11,$04,$01,$0D,$02,$0F,$01,$05
 DATA $01,$05,$12,$0F,$11,$04,$01,$0D,$02,$0F

 DATA $FF,$00,$CC,$00,$AA,$00,$88,$00,$55,$00
 DATA $55,$00,$FF,$00,$CC,$00,$AA,$00,$88,$00
 DATA $88,$00,$55,$00,$FF,$00,$CC,$00,$AA,$00
 DATA $AA,$00,$88,$00,$55,$00,$FF,$00,$CC,$00
 DATA $CC,$00,$AA,$00,$88,$00,$55,$00,$FF,$00

 DATA $3F,$00,$0F,$07,$F0,$07,$00,$0F,$B0,$0F
 DATA $B0,$0F,$3F,$00,$0F,$07,$F0,$07,$00,$0F
 DATA $00,$0F,$B0,$0F,$3F,$00,$0F,$07,$F0,$07
 DATA $F0,$07,$00,$0F,$B0,$0F,$3F,$00,$0F,$07
 DATA $0F,$07,$F0,$07,$00,$0F,$B0,$0F,$3F,$00


## The LO Pointer sets for the above
## Palettes when loaded.  Hi Pointer will
## Be chosen by What Page we choose.
PALPOINTER.SET1:
  DATA $00,$0A,$14,$1E,$28
PALPOINTER.SET2:
  DATA $32,$3C,$46,$50,$5A
PALPOINTER.SET3:
  DATA $64,$6E,$78,$82,$8C
PALPOINTER.SET4:
  DATA $96,$A0,$AA,$B4,$BE
PALPOINTER.SET5:
  DATA $C8,$D2,$DC,$E6,$F0

## Sprite definition for *Spin* frames
## Sprite Number & X/Y *Flip*
FRAMEDATA:
  DATA 1,0, 2,0,3,0,4,0,5,0,4,2,3,2,2,2,1,2
  DATA 2,3,3,3,4,3,5,1,4,1,3,1,2,1

## X Coordinates for the Slot "Reels"
XPOSITIONS:
 DATA 45,128,211

## BITMAP MASKS TO BE READ INTO BIT.MASK() ARRAY PRIOR TO
## CALLING BIGWORD.  USED TO MASK OUT THE ROM FONT
BITMAPS:
  DATA 128,64,32,16,8,4,2,1,0

## Machine language code for Alternate Ctrl-C/BRK
## Handler.  Source code in STOPVEC.S
STOPHANDLER:
  DATA $620,234,169,0,133,112,173,40,3,141,74,6,173,41,3,141,75,6,120,169,73,141,40,3,169,6,141
  DATA 41,3,173,32,6,141,86,6,169,96,141,32,6,88,96,32,255,255,240,3,169,3,96,169,27,133,112,96,96
  DATA 120,173,74,6,141,40,3,173,75,6,141,41,3,173,86,6,141,32,6,169,96,141,86,6,88,96,-1

## The ASCII codes to draw a "Box" in
## cp437 characters
CP437DRAW:
  DATA $C9,$CD,$BB,$BA,$BA,$C8,$CD,$BC

POKEMLROUTINE:
  READ PAddr
  READ C
  FOR I = 0 TO -1 STEP 0
      PRINT ".";
      POKE PAddr, C
      PAddr = PAddr + 1
      READ C
      I = (C<0)
  NEXT
  PRINT
RETURN

